package nova;

import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


/** The Boost Block
 * Extension of Block class to manage Boost parameters
 */
public class Boost extends CopyBlock {

    Nibble level;
    Nibble onoff;

    public Boost(Patch par) {	
	super("Boost", par, true);

	try {
	    level = parent.getNibble(37);
	    level.updateNibble("Level (dB)", Nibble.TYPE_0_10);
	    nibbles.add( level );

	    onoff = parent.getNibble(38);
	    onoff.updateNibble("On",Nibble.TYPE_ONOFF);
	    nibbles.add( onoff );

	} catch (Exception e) {
	    System.err.println("Not enough Nibbles to load Boost Block");
	}

	refresh();
    }

    /* reformat the widgets */
    void refresh() {
	box.removeAll();
	int i = 0;
	activeNibbles = new int[]{ 38, 37 };
	box.add( new Row("Boost", onoff, i++));
	box.add( new Row("Boost", level, i++));

	while (i<9) box.add( new EmptyRow(true, i++));    


    }

    int getBlockType(Box b) {
	return BOOST;
    }

    int[] getActiveNibbles(Box b) {
	return activeNibbles;
    }

    void setActiveNibbles(Box b, int[] an) {
	activeNibbles = an;
    }
}

