package nova;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/** A RowPopup is a Popup displaying allowed values for it 
*/
public class CopyPastePopup extends Window implements MouseListener {

    private NovaManager parent;
    CopyBlock cb;
    Box b;
    private int x;
    private int y;
    GridBagConstraints gc;

    final static Font normalFont = new Font("Tahoma", Font.PLAIN, 14);
    final static Font boldFont = new Font("Tahoma", Font.BOLD, 14);

    public CopyPastePopup(NovaManager parent, CopyBlock cb, Box b, int x, int y) {
	super(parent);
	this.parent = parent;
	this.cb = cb;
	this.b = b;
	this.x = x;
	this.y = y;

	setLayout( new GridBagLayout());
	gc = new GridBagConstraints();
	gc.insets = new Insets(2,5,2,5);
	setContent();
	setLocation(x,y);
    }

    void setContent() {
	removeAll();

	Box b = Box.createVerticalBox();
	
	JLabel lcopy = new JLabel("Copy");
	lcopy.setFont(normalFont);
	lcopy.addMouseListener(this);
	b.add(lcopy);

	JLabel lpaste = new JLabel("Paste");
	lpaste.setFont(normalFont);
	if ((CopyBlock.isBufferFull == false) || (cb.getBlockType(b) != CopyBlock.bufferType))
	    lpaste.setForeground( Color.gray );
	else lpaste.addMouseListener(this);
	b.add(lpaste);

	add(b, gc);
    }

    public void setVisible(boolean state) {
	super.setVisible( state && parent.isEditable() );
    }

    // == MOUSE LISTENER INTERFACE //
    public void mouseClicked(MouseEvent e) {
	String s ="";
	JLabel lab = (JLabel) e.getSource();
	s = lab.getText();

	if (s.equalsIgnoreCase("Copy")) CopyBlock.copy(cb,b);
	else if (s.equalsIgnoreCase("Paste")) CopyBlock.paste(cb,b);

	setVisible(false);
    }

    public void mousePressed(MouseEvent e) {
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
 
}