package nova;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

/** A RowPopup is a Popup displaying allowed values for it 
*/
public class EditName extends Window implements ActionListener, ChangeListener {

    private NovaManager parent;
    private Patch p;
    private int x;
    private int y;
    private GridBagConstraints gc;

    private JCheckBox cb ;
    private JComboBox bank;
    private JComboBox number;
    private JTextField tf;

    public EditName(NovaManager parent) {
	super(parent);

	setLayout( new GridBagLayout());
	gc = new GridBagConstraints();
	gc.insets = new Insets(2,5,2,5);
	
	gc.gridwidth = 2;
	cb = new JCheckBox( "Current preset" );
	cb.addChangeListener(this);
	add(cb, gc);

	gc.gridy = 1;
	gc.gridx = 0;
	gc.gridwidth = 1;
	JLabel lab = new JLabel("User bank");
	add(lab, gc);

	gc.gridx = 1;
	bank = new JComboBox(Constants.BANKS);
	add(bank, gc);
	
	gc.gridx = 2;
	number = new JComboBox(Constants.NUM);
	add(number, gc);

	gc.gridy = 3;
	gc.gridx = 0;
	gc.gridwidth=4;
	tf = new JTextField(24);
	add(tf, gc);

	gc.gridy = 4;
	gc.gridx = 0;
	gc.gridwidth=2;
	JButton cancel = new JButton("Cancel");
	cancel.setActionCommand("Cancel");
	cancel.addActionListener(this);
	add(cancel, gc);

	gc.gridx = 2;
	gc.gridwidth=2;
	JButton ok = new JButton("OK");
	ok.setActionCommand("OK");
	ok.addActionListener(this);
	add(ok, gc);
    }

    void update(Patch p, int x, int y) {
	setLocation(x, y);
	this.p = p;
	//set JComponents state according to Patch attributes
	//numcode, bank, preset, name
	int num = p.getPresetCode();
	int bk = p.getOriginalBankNumber();
	int n = p.getOriginalPresetNumber();
	String name = p.getOriginalName();

	if (num == 0) {
	    setState(true);
	    bank.setSelectedIndex(0);
	    number.setSelectedIndex(0);
	}
	else {
	    setState(false);
	    bank.setSelectedIndex(bk);
	    number.setSelectedIndex(n-1);
	}

	tf.setText( name );
	pack();
	setVisible(true);
    }

    private void setState(boolean enabled) {
	cb.setSelected( enabled );
	bank.setEnabled( !enabled );
	number.setEnabled( !enabled );
    }

    void save() {
	//get values from JComponents
	//and save them as Patch attributes
	if (cb.isSelected()) p.setPresetCode(0);
	else {
	    int b = bank.getSelectedIndex();
	    int pr = number.getSelectedIndex()+1;
	    
	    p.setBankNumber( b );
	    p.setPresetNumber( pr );
	    p.setPresetCode( 30 + 3*b + pr);
	}

	p.setPresetName(tf.getText());
	p.refreshTitle();
	setVisible(false);
    }

    public void actionPerformed(ActionEvent e) {
	String com = e.getActionCommand();
	if (com.equals("Cancel")) setVisible(false);
	else if (com.equals("OK")) save();
    }

    public void stateChanged(ChangeEvent e) {
	setState( cb.isSelected());
    }
 
}