package nova;

import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

/** SubClass of Row with alternate background
 * Either dark : alternatively gray1 and gray2
 * Or light : alternatively white and blue
 * Used for displaying parameters in a tabular form
*/
public class EmptyRow extends Row {

    int isDark = 0;
    
    public EmptyRow( boolean dark, int rank ) {
	super(null, null, rank);
	if (dark) isDark=1;

	int parity = (rank % 2);

	setOpaque(true);
	switch (2*isDark+parity) {
	case 0: setBackground(Color.white);
	    break;
	case 1: setBackground(blue);
	    break;
	case 2: setBackground(gray2);
	    break;
	case 3: setBackground(gray1);
	    break;
	}
    }

}

