package nova;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

/** Dialog telling an Error has occured
 * e.g. wrong SysEx format
 */
public class ErrorDialog extends JDialog implements ActionListener {

    NovaManager parent;
    JLabel msg = new JLabel("", SwingConstants.CENTER);
    private Dimension size = new Dimension(200, 150);

    public ErrorDialog(NovaManager nm) {
	super(nm, true);
	parent = nm;
	
	Container p = getContentPane();
	p.setLayout(new BorderLayout());

	JButton ok = new JButton("OK");
	ok.setActionCommand("ok");
	ok.addActionListener(this);
	p.add(msg, BorderLayout.CENTER);
	
	JPanel f = new JPanel();
	f.add(ok);
	p.add(f, BorderLayout.PAGE_END);

	setMinimumSize( size );
	setVisible(false);
    }

    void setMessage(String m) {
	msg.setText(m);
	pack();
	setVisible(true);
    }

    public void actionPerformed(ActionEvent e) {
	setVisible(false);
    }
    
}