package nova;
import javax.sound.midi.MidiMessage;

public class MMidiMessage extends MidiMessage {
    int status = 0;
    int channel = 0;

    public MMidiMessage( byte[] b ) {
	super(b);
	update();
	//setMessage(b);
    }

    public void setMessage( byte[] b ) {
	length = b.length;
	data = new byte[length];
	System.arraycopy(b, 0, data, 0, length);

	update();
    }

    private void update() {
	if (length>0) {
	    this.status = (data[0] & 0xFF) / 16;
	    this.channel = (data[0] & 0xFF) % 16;
	}
    }

    protected void setMessage( byte[] b, int length ) {
	setMessage(b);
    }

    public int getStatus() {
	return this.status;
    }

    public int getChannel() {
	return this.channel;
    }

    public Object clone() {
	byte[] cpy = new byte[length];
	System.arraycopy(data, 0, cpy, 0, length);
	return new MMidiMessage(cpy);
    }

    public String toString() {
	String s = "";
	s += "Status = "+Integer.toHexString(this.status).toUpperCase();
	s += "\nChannel = "+Integer.toHexString(this.channel).toUpperCase();
	s += "\nData = ";
	for (int i=0; i< length; i++)
	    s += Integer.toHexString(data[i] & 0xFF).toUpperCase() + " ";
	return s;
    }
}