package nova;

/** The MidiCC Block
 * Extension of Block class to manage MidiCC parameters
 * in SystemDump
 * Does nothing more than gathering Nibbles 
 * (display is done directly in SystemDump)
 */
public class MidiCC extends Block {

    public MidiCC(SystemDump par) {	
	super("MIDI CC", par);
	rowspan = 2;

	activeNibbles = new int[] {8, 10, 9, 14, 
				   16, 17, 11, 15, 
				   12, 13, 18};

	for (int i=0; i<activeNibbles.length; i++)
	    nibbles.add( system.getNibble( activeNibbles[i] ) );
    }

    /* reformat the widgets */
    void refresh() {
    }

}

