package nova;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiDevice;
import javax.sound.midi.Sequencer;
import javax.sound.midi.Synthesizer;
import javax.sound.midi.MidiDevice.Info;
import javax.sound.midi.Receiver;
import javax.sound.midi.Transmitter;
import javax.sound.midi.MidiUnavailableException;

import javax.sound.midi.MidiMessage;
import javax.sound.midi.SysexMessage;
import javax.sound.midi.ShortMessage;
import javax.sound.midi.InvalidMidiDataException;


/* 2nd version of MidiDefaultInterface for tackle the Java Bug
   Open and Close device after every SysEx sent
*/
public class MidiDefaultInterface2 extends MidiDefaultInterface {

    public MidiDefaultInterface2() {
	super();
    }

    public MidiDefaultInterface2(NovaManager np) {
	super(np);
    }

    void setComboListeners() {
	ib.addActionListener(new ActionListener(){	
		/* Need a MidiInputBuffer BEFORE the buildInterface */
		public void actionPerformed(ActionEvent e) {
		    if (ib.getSelectedIndex() <0) return;
		    try{
			if (currentInPort != null) currentInPort.close();
			currentInPort= javax.sound.midi.MidiSystem.getMidiDevice(ins[ib.getSelectedIndex()]);
			currentInPort.open();
			Transmitter t = currentInPort.getTransmitter();
			t.setReceiver( buffer );
		    }catch (MidiUnavailableException mue){
			parent.logSilent("can't open MidiIn : " +mue.toString());
		    }

		    if (currentOutPort != null) lookUp();	    
		}		    		
	    });
	
	ob.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    if (ob.getSelectedIndex() <0) return;		    		    
		    try{
			if (currentOutPort!= null) currentOutPort.close();
			currentOutPort= javax.sound.midi.MidiSystem.getMidiDevice(outs[ob.getSelectedIndex()]);
			//currentOutPort.open();
			//receiver = currentOutPort.getReceiver();
			lookUp();	    
		    }catch (MidiUnavailableException mue){
			parent.logSilent("can't open MidiOut : " +mue.toString());
		    }
		}
	    });
    }

    void send(byte[] data) {
	MMidiMessage msg = new MMidiMessage(data);
	parent.logSilent("Sending Message :");
	parent.logSilent(msg.toString());

	try {
	    currentOutPort.open();

	    receiver = currentOutPort.getReceiver();

	    if (receiver != null) {
		parent.logSilent("Receiver found : transmitting message");
		receiver.send( msg, -1);
	    } else { 
		parent.logSilent("No output device : message not sent");
	    }
	    currentOutPort.close();
	} catch (MidiUnavailableException mue){
	    parent.logSilent("Device can't be opened : message not sent");
	}
	parent.logSilent();
    }

}
			
