package nova;

import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

/** Extension of Row for displaying MidiMapIn Parameters
 * 3 values in the same cell
 */
public class MidiMapInRow extends Row {

    private int n;
    static final Font valueFont = new Font("Tahoma", Font.PLAIN, 9);

    public MidiMapInRow( int i, Nibble parent, int rank ) {
	super("", parent, rank);
	this.parent = parent;
	this.n = i;
	doit();
	addMouseListener(this);
    }
    void init() {}

    int getN() {
	return n;
    }

    void doit() {
	JLabel l;
	int val;
	String preset ;

	removeAll();
	setLayout( new GridLayout(1,3));
	l = new JLabel("", SwingConstants.CENTER);
	val = parent.getMapMidiValue1();
	if ((val > 0) && (val < 91)) preset = Constants.PRESET[val];
	else preset = "None";
	l.setText( ""+(3*n+1) + " > " + preset );
	l.setFont( valueFont );
	add(l);

	l = new JLabel("", SwingConstants.CENTER);
	if (3*n+2 < 128) {
	    val = parent.getMapMidiValue2();
	    if ((val > 0) && (val < 91)) preset = Constants.PRESET[val];
	    else preset = "None";
	    l.setText( ""+(3*n+2) + " > " + preset);
	    l.setFont( valueFont );
	}
	add(l);

	l = new JLabel("", SwingConstants.CENTER);
	if (3*n+3 < 128) {
	    val = parent.getMapMidiValue3();
	    if ((val > 0) && (val < 91)) preset = Constants.PRESET[val];
	    else preset = "None";
	    l.setText( ""+(3*n+3) + " > " + preset);
	    l.setFont( valueFont );
	}
	add(l);
    }    

   public void mouseClicked(MouseEvent e) {
	Component c = (Component) e.getSource();
	Point pos = c.getLocationOnScreen();
	int x = e.getX() + pos.x;
	int y = e.getY() + pos.y;

	while (c != null) {
	    c = c.getParent();
	    if (c instanceof NovaManager) break;
	}

	if (c instanceof NovaManager) {
	    NovaManager nm = (NovaManager) c;
	    MidiRowPopup np = new MidiRowPopup( nm, this, x, y);
	    np.pack();
	    nm.setPopup(np);
	}
       
    }
}

