package nova;

import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

/** Extension of Row for displaying MidiMapOut Parameters
 * 3 values in the same cell
 */
public class MidiMapOutRow extends Row {

    private int n;
    static final Font valueFont = new Font("Tahoma", Font.PLAIN, 9);

    public MidiMapOutRow( int i, Nibble parent, int rank ) {
	super("", parent, rank);
	this.parent = parent;
	this.n = i;
	addMouseListener(this);
	doit();
    }
    void init() {}

    int getN() {
	return n;
    }

    void doit() {
	JLabel l;
	int val;
	String preset ;

	removeAll();
	setLayout( new GridLayout(1,3));
	l = new JLabel("", SwingConstants.CENTER);
	val = parent.getMapMidiValue1();
	preset = Constants.PRESET[31+3*n];
	l.setText( preset + " > " + val );
	l.setFont( valueFont );
	add(l);

	l = new JLabel("", SwingConstants.CENTER);
	val = parent.getMapMidiValue2();
	preset = Constants.PRESET[32+3*n];
	l.setText( preset + " > " + val );
	l.setFont( valueFont );
	add(l);

	l = new JLabel("", SwingConstants.CENTER);
	val = parent.getMapMidiValue3();
	preset = Constants.PRESET[33+3*n];
	l.setText( preset + " > " + val );
	l.setFont( valueFont );
	
	add(l);
    }    

   public void mouseClicked(MouseEvent e) {

	Component c = (Component) e.getSource();
	Point pos = c.getLocationOnScreen();
	int x = e.getX() + pos.x;
	int y = e.getY() + pos.y;

	while (c != null) {
	    c = c.getParent();
	    if (c instanceof NovaManager) break;
	}

	if (c instanceof NovaManager) {
	    NovaManager nm = (NovaManager) c;
	    MidiRowPopup np = new MidiRowPopup( nm, this, x, y);
	    np.pack();
	    nm.setPopup(np);
	}
       
    }
}

