package nova;

/** The MidiSetUp Block
 * Extension of Block class to manage MidiSetUp parameters
 * in SystemDump
 * Does nothing more than gathering Nibbles 
 * (display is done directly in SystemDump)
 */
public class MidiSetUp extends Block {

    public MidiSetUp(SystemDump par) {	
	super("MIDI SetUp", par);
	rowspan = 1;

	activeNibbles = new int[] {19, 20, 21, 23, 24, 22};

	for (int i=0; i<activeNibbles.length; i++)
	    nibbles.add( system.getNibble( activeNibbles[i] ) );

    }

    /* reformat the widgets */
    void refresh() {
    }

}

