package nova;

/** Exception thrown when a Nibble has to be created with a wrong value
 */
public class NibbleException extends Exception {
    int type;
    String msg;
    byte[] badArray;
    int badValue;
    static final String MSG0 = "null byte array not acceptable for Nibble";
    static final String MSG1 = "byte array size not acceptable for Nibble";
    static final String MSG2 = "byte 3 in array not acceptable for Nibble";
    static final String MSG3 = "byte 2 in array not acceptable for Nibble";
    static final String MSG4 = "byte 0/1 in array not acceptable for Nibble";
    static final String MSG5 = "value to low for Nibble";
    static final String MSG6 = "value to high for Nibble";
    
    public NibbleException(int err, byte[] b) {
	super();
	this.type = err;
	this.badArray = b;
	setMessage();
    }

    public NibbleException(int err, int v) {
	super();
	this.type = err;
	this.badValue = v;
	setMessage();
    }
    
    private void setMessage() {
	if (type == 0) msg = MSG0;
	else if (type == 1) msg = MSG1 + " ("+badArray.length+")"  ;
	else if (type == 2) msg = MSG2 + " ("+badArray[3]+")" ;
	else if (type == 3) msg = MSG3 + " ("+badArray[2]+")"  ;
	else if (type == 4) msg = MSG4 + " ("+badArray[2]+"|"+badArray[1]+")" ;
	else if (type == 5) msg = MSG5 + " ("+badValue+")"   ;
	else if (type == 6) msg = MSG6 + " ("+badValue+")"   ;
    }

    public String getMessage() {
	return msg;
    }
}