
package nova;
import javax.swing.*;
import java.awt.*;
import java.util.*;

/* Logger : Writes to "NovaManager.log" */
public class NovaLog extends JFrame {
    private JTextArea text;

    public NovaLog() {
	super("MIDI Console");
	setDefaultCloseOperation(this.HIDE_ON_CLOSE);
	setVisible(false);
	text = new JTextArea();
	JScrollPane scrollPane = new JScrollPane(text);
	this.getContentPane().add(scrollPane);
	setSize(new Dimension(400, 300));

	appendSilent("OS Name: "+System.getProperty("os.name"));
	appendSilent("OS version: "+System.getProperty("os.version"));
	appendSilent("Java version: "+System.getProperty("java.version"));
	appendSilent("Java arch: "+System.getProperty("sun.arch.data.model"));
	appendSilent("--");
    }

    public void appendSilent(String s) {
	text.append(s+"\n");
	scrollDown();
    }

    public void append(String s) {
	appendSilent(s);
	scrollDown();
	if (!isVisible()) setVisible(true);
    }
    
    private void scrollDown() {
	text.setCaretPosition( text.getText().length() );
    }
}
			

