package nova;

/** Exception thrown when a Nibble has to be created with a wrong value
 */
public class OutOfBoundsException extends Exception {
    String msg;
    
    public OutOfBoundsException(String s) {
	super();
	this.msg = s;
    }

    // Errors at Decoding (int => String)
    public OutOfBoundsException(int val, Nibble source) {
	super();
	this.msg = "Field '"+source.getName()+"': Value Out of Bounds ("+val+")";
	if (source.getType() >= Nibble.TYPE_INT) 
	    this.msg +="\nUsing default value: "+source.getValue();
	else
	    this.msg +="\nUsing default value: "+source.getValue()+ " ("+source.getStringValue()+")";    
   }

    // Errors at Encoding (String => int)
    public OutOfBoundsException(String val, Nibble source) {
	super();
	this.msg = "Field '"+source.getName()+"': Unknown Value ("+val+")";
	if (source.getType() >= Nibble.TYPE_INT) 
	    this.msg +="\nUsing default value: "+source.getValue();
	else
	    this.msg +="\nUsing default value: "+source.getValue()+ " ("+source.getStringValue()+")";    }

    public String getMessage() {
	return msg;
    }
}