package nova;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/** A VarPopup is a Popup displaying variation number
*/
public class VarPopup extends Window implements MouseListener {

    private NovaManager parent;
    private Variation v;
    private int x;
    private int y;
    private GridBagConstraints gc;

    public VarPopup(NovaManager parent, Variation var, int x, int y) {
	super(parent);
	this.parent = parent;
	this.v = var;
	this.x = x;
	this.y = y;

	setLayout( new GridBagLayout());
	gc = new GridBagConstraints();
	gc.insets = new Insets(2,5,2,5);
	setContent();
	setLocation(x,y);
    }

    void setContent() {
	removeAll();
	int n = v.getNumber();

	Box b = Box.createVerticalBox();
	for (int i=1; i<=4; i++) {
	    JLabel lab = new JLabel(""+i);
	    if (i==n) lab.setFont(RowPopup.boldFont);
	    else lab.setFont(RowPopup.normalFont);
	    lab.addMouseListener(this);
	    b.add(lab);
	}
	add(b, gc);
    }
    
    /* call the parent component to set the new Nibble value and refresh */
    void update(String s) {
	try {
	    int i = Integer.parseInt(s);
	    v.setNumber(i);
	    v.refreshTitle();
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

    // == MOUSE LISTENER INTERFACE //
    public void mouseClicked(MouseEvent e) {
	String s ="";
	JLabel lab = (JLabel) e.getSource();
	s = lab.getText();
	update(s);
	setVisible(false);
    }

    public void mousePressed(MouseEvent e) {
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
 
}